﻿using DTO.Responses;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Xml;
using System.Xml.Linq;
using TPChapitre4.Common;
using TPChapitre4.DTO;
namespace TPChapitre4.DAL
{
    public class DataHelper
    {
        static DataHelper()
        {
            _instance = new DataHelper();
        }

        private static DataHelper _instance;
        public static DataHelper Instance
        {
            get { return _instance; }
        }

        private static string _path = @"C:\Users\User\Desktop\tp.chapitre.4\DB.xml";
        public static string Path
        {
            get { return _path; }
        }

        public GetProfileResponseDTO GetProfileQuery(GetProfileRequestDTO objProfileRequest)
        {
            GetProfileResponseDTO objGetProfileResponse;
            try
            {
                XElement xElement = XElement.Load(Path);

                objGetProfileResponse = (from u in xElement.Elements("user")
                        where (string)u.Attribute("id") == objProfileRequest.UserID.ToString()
                        select new GetProfileResponseDTO
                         {
                             Id = objProfileRequest.UserID,
                             Fullname = u.Element("fullname").Value.ToString(),
                             City = u.Element("city").Value.ToString(),
                             ImageURL = u.Element("imageUrl").Value.ToString(),
                             Likes = Convert.ToInt32(u.Element("likes").Value),
                             TotalFollowers = Convert.ToInt32(u.Element("totalFollowers").Value),
                             TotalFollowing = Convert.ToInt32(u.Element("totalFollowing").Value.ToString()),
                             TotalPosts = Convert.ToInt32(u.Element("totalPosts").Value.ToString())
                         }).FirstOrDefault();

                if (objGetProfileResponse != null)
                {
                    objGetProfileResponse.Status = new ResponseCode()
                    {
                        Code = StatusCodes.Success,
                        Message = StatusMessages.Success
                    };
                }
                else
                {
                    objGetProfileResponse = new GetProfileResponseDTO()
                    {
                        Status = new ResponseCode()
                        {
                            Code = StatusCodes.InexistantUser,
                            Message = StatusMessages.InexistantUser
                        }
                    };
                }
            }
            catch (Exception ex)
            {
                objGetProfileResponse = new GetProfileResponseDTO()
                {
                    Status = new ResponseCode()
                    {
                        Code = StatusCodes.Error,
                        Message = StatusMessages.Error
                    }
                };
            }
            return objGetProfileResponse;
        }
        public SaveProfileResponseDTO SaveProfileQuery(SaveProfileRequestDTO objProfileRequest)
        {
           SaveProfileResponseDTO objSaveProfileResponse;
           try
           {
               XElement xElement = XElement.Load(Path);

               XElement user = (from u in xElement.Elements("user")
                           where (string)u.Attribute("id") == objProfileRequest.UserID.ToString()
                           select (XElement) u).FirstOrDefault();

               user.Element("fullname").Value = objProfileRequest.FullName;
               user.Element("city").Value = objProfileRequest.City;

               xElement.Save(Path);

               objSaveProfileResponse = new SaveProfileResponseDTO()
               {
                   Status = new ResponseCode()
                   {
                       Code = StatusCodes.Success,
                       Message = StatusMessages.Success
                   }
               };
           }
           catch (Exception ex)
           {
               objSaveProfileResponse = new SaveProfileResponseDTO()
               {
                   Status = new ResponseCode()
                   {
                       Code = StatusCodes.Error,
                       Message = StatusMessages.Error
                   }
               };
           }
           return objSaveProfileResponse;
        }
    }
}