﻿using SL.Models;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using TPChapitre4.BLL;
using TPChapitre4.DTO;
namespace TPChapitre4.SL.Controllers
{
    [RoutePrefix("api/User")]
    public class UserController : ApiController
    {
        IUserManager userManager;
     
        [Route("{id}/Profile")]
        [HttpGet]
        public HttpResponseMessage Profile(int id)
        {
            userManager = new UserManager();
            GetProfileRequestDTO objProfileRequest = new GetProfileRequestDTO()
            {
                UserID = id
            };
            GetProfileResponseDTO objProfileResponse = userManager.FetchProfile(objProfileRequest);
            return Request.CreateResponse(HttpStatusCode.InternalServerError, objProfileResponse);
        }

        [Route("Profile")]
        [HttpPost]
        public HttpResponseMessage Profile(SaveProfileRequestModel objSaveProfileRequestModel)
        {
            userManager = new UserManager();
            SaveProfileRequestDTO objSaveProfileRequestDTO = new SaveProfileRequestDTO()
            {
                City = objSaveProfileRequestModel.City,
                FullName = objSaveProfileRequestModel.FullName,
                UserID = objSaveProfileRequestModel.UserID
            };
            SaveProfileResponseDTO objSavePofileResponse = userManager.SaveProfile(objSaveProfileRequestDTO);
            SaveProfileResponseModel objSaveProfileResponseModel = new SaveProfileResponseModel()
            {
                Status = objSavePofileResponse.Status
            };
            return Request.CreateResponse(HttpStatusCode.OK, objSavePofileResponse);
        }
    }
}
    

